"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const constants_1 = require("./constants");
const HttpClient_1 = __importDefault(require("./HttpClient"));
const Authorization_1 = __importDefault(require("./modules/Authorization"));
const Feature_1 = __importDefault(require("./modules/Feature"));
const Permission_1 = __importDefault(require("./modules/Permission"));
const PricingTier_1 = __importDefault(require("./modules/PricingTier"));
const Role_1 = __importDefault(require("./modules/Role"));
const Session_1 = __importDefault(require("./modules/Session"));
const Tenant_1 = __importDefault(require("./modules/Tenant"));
const User_1 = __importDefault(require("./modules/User"));
const WarrantModule_1 = __importDefault(require("./modules/WarrantModule"));
class WarrantClient {
    constructor(config) {
        this.Authorization = Authorization_1.default;
        this.Feature = Feature_1.default;
        this.Permission = Permission_1.default;
        this.PricingTier = PricingTier_1.default;
        this.Role = Role_1.default;
        this.Session = Session_1.default;
        this.Tenant = Tenant_1.default;
        this.User = User_1.default;
        this.Warrant = WarrantModule_1.default;
        WarrantClient.config = config;
        WarrantClient.httpClient = new HttpClient_1.default({
            apiKey: config.apiKey,
            baseUrl: config.endpoint || constants_1.API_URL_BASE,
        });
    }
}
exports.default = WarrantClient;
