import { CreateFeatureParams, ListFeatureOptions } from "../types/Feature";
import { WarrantRequestOptions } from "../types/WarrantRequestOptions";
import Warrant, { WarrantObject } from "../types/Warrant";
export default class Feature implements WarrantObject {
    featureId: string;
    constructor(featureId: string);
    static create(feature: CreateFeatureParams, options?: WarrantRequestOptions): Promise<Feature>;
    static get(featureId: string, options?: WarrantRequestOptions): Promise<Feature>;
    static delete(featureId: string, options?: WarrantRequestOptions): Promise<void>;
    static listFeatures(listOptions?: ListFeatureOptions, options?: WarrantRequestOptions): Promise<Feature[]>;
    static listFeaturesForPricingTier(pricingTierId: string, listOptions?: ListFeatureOptions, options?: WarrantRequestOptions): Promise<Feature[]>;
    static assignFeatureToPricingTier(pricingTierId: string, featureId: string, options?: WarrantRequestOptions): Promise<Warrant>;
    static removeFeatureFromPricingTier(pricingTierId: string, featureId: string, options?: WarrantRequestOptions): Promise<void>;
    static listFeaturesForTenant(tenantId: string, listOptions?: ListFeatureOptions, options?: WarrantRequestOptions): Promise<Feature[]>;
    static assignFeatureToTenant(tenantId: string, featureId: string, options?: WarrantRequestOptions): Promise<Warrant>;
    static removeFeatureFromTenant(tenantId: string, featureId: string, options?: WarrantRequestOptions): Promise<void>;
    static listFeaturesForUser(userId: string, listOptions?: ListFeatureOptions, options?: WarrantRequestOptions): Promise<Feature[]>;
    static assignFeatureToUser(userId: string, featureId: string, options?: WarrantRequestOptions): Promise<Warrant>;
    static removeFeatureFromUser(userId: string, featureId: string, options?: WarrantRequestOptions): Promise<void>;
    getObjectType(): string;
    getObjectId(): string;
}
