import { CreatePermissionParams, ListPermissionOptions, UpdatePermissionParams } from "../types/Permission";
import { WarrantRequestOptions } from "../types/WarrantRequestOptions";
import Warrant, { WarrantObject } from "../types/Warrant";
export default class Permission implements WarrantObject {
    permissionId: string;
    name?: string;
    description?: string;
    constructor(permissionId: string, name?: string, description?: string);
    static create(permission: CreatePermissionParams, options?: WarrantRequestOptions): Promise<Permission>;
    static get(permissionId: string, options?: WarrantRequestOptions): Promise<Permission>;
    static update(permissionId: string, permission: UpdatePermissionParams, options?: WarrantRequestOptions): Promise<Permission>;
    static delete(permissionId: string, options?: WarrantRequestOptions): Promise<void>;
    static listPermissions(listOptions?: ListPermissionOptions, options?: WarrantRequestOptions): Promise<Permission[]>;
    static listPermissionsForUser(userId: string, listOptions?: ListPermissionOptions, options?: WarrantRequestOptions): Promise<Permission[]>;
    static assignPermissionToUser(userId: string, permissionId: string, options?: WarrantRequestOptions): Promise<Warrant>;
    static removePermissionFromUser(userId: string, permissionId: string, options?: WarrantRequestOptions): Promise<void>;
    static listPermissionsForRole(roleId: string, listOptions?: ListPermissionOptions, options?: WarrantRequestOptions): Promise<Permission[]>;
    static assignPermissionToRole(roleId: string, permissionId: string, options?: WarrantRequestOptions): Promise<Warrant>;
    static removePermissionFromRole(roleId: string, permissionId: string, options?: WarrantRequestOptions): Promise<void>;
    getObjectType(): string;
    getObjectId(): string;
}
